#!/usr/bin/env python

import gtk
import gtk.glade
import pango
from easyfiles import *

from usp_util import icon_factory

def EvalColor( colorToTest ):
	if colorToTest[0] != '#' or len( colorToTest ) !=7:
		return False
	for i in colorToTest[1:]:
		if i not in ['a', 'A', 'b', 'B', 'c', 'C', 'd', 'D', 'e', 'E', 'f', 'F', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9']:
			return False
	return True

def MakeAButton( ButtonWidth, ButtonHeight, Relief, IconName, IconSize, IconWidth, IconHeight, ButtonLabels, ButtonStyles ):

		if IconSize == 4 or IconSize > 4:
			icon_size = gtk.ICON_SIZE_DIALOG
			IconSpacing = 80
		elif IconSize == 3:
			icon_size = gtk.ICON_SIZE_DND
			IconSpacing = 60
		elif IconSize == 2:
			icon_size = gtk.ICON_SIZE_BUTTON
			IconSpacing = 40
		elif IconSize == 1 or IconSize < 1:
			icon_size = gtk.ICON_SIZE_MENU
			IconSpacing = 40

		AButton = gtk.Button( "", "ok", True )
		AButton.remove( AButton.get_children()[0] )
		AButton.set_size_request( ButtonWidth, ButtonHeight )
		AButton.set_relief( Relief )

		Align1 = gtk.Alignment( 0, 0.5, 0, 0 )
		Align1.set_padding( 0, 0, 0, 0 )
		HBox1 = gtk.HBox()
		VBox1 = gtk.VBox( False, 2 )
		VBox1.set_homogeneous( False )
		VBox1.show()

		count = 0
		for items in ButtonLabels:
			Label1 = gtk.Label( items )
			Label1.show()
			Label1.set_size_request( ButtonWidth, -1 )
			Label1.set_ellipsize( pango.ELLIPSIZE_END )

			if ButtonStyles[count] != [""]:
				ItemStyle = pango.AttrList()
				for x in range( len( ButtonStyles[count] ) ):
					#print ButtonStyles[count]
					#ItemStyle = pango.AttrList()
					attr = ButtonStyles[count][x]
					ItemStyle.insert( attr )
				Label1.set_attributes( ItemStyle )
				Label1.set_alignment( 0, 0.5 )

			VBox1.add( Label1 )
			count = count + 1

		if IconName != "":
			try:
				ButtonIcon = icon_factory.load_image( IconName, icon_size )
			except:
				ButtonIcon = icon_factory.load_image( "gnome-unknown", icon_size )
				pass
			ButtonIcon.set_size_request( IconWidth+IconSpacing, IconHeight )
			HBox1.add( ButtonIcon )

		HBox1.add( VBox1 )
		HBox1.show()
		Align1.add( HBox1 )
		Align1.show()
		AButton.add( Align1 )
		AButton.show()

		return AButton
