#!/usr/bin/env python
# USP Places2 plugin

import gtk
import gtk.glade
import sys
import os
import gobject
import gconf
import gnomevfs
import string

from easyfiles import *
from easybuttons import *
from execute import *
from easygconf import *
from usp_util import *

class BookmarkDialog:
	def __init__(self):
		self.gladefile = os.path.join(os.path.dirname( __file__ ), "places.glade")
		return
	def run(self,bookname):
		"""This function will show the Edit Dialog"""
		self.wTree = gtk.glade.XML(self.gladefile, "BookmarkDialog")
		#Get the actual dialog widget
		self.dlg = self.wTree.get_widget("BookmarkDialog")

		self.wTree.get_widget("BookmarkDialogEntry").set_text(bookname)

		#run the dialog and store the response
		self.result = self.dlg.run()
		if self.result == -5:
			GotData = self.wTree.get_widget("BookmarkDialogEntry").get_text()
		else:
			GotData = ""

		self.dlg.destroy()
		return GotData

class pluginclass:
    def __init__( self, USPWin ):

	self.USPWin = USPWin
        # The Glade file for the plugin
        self.gladefile = os.path.join( os.path.dirname( __file__ ), "places.glade" )

        # Read GLADE file
        self.wTree = gtk.glade.XML( self.gladefile, "window1" )
        self.PlaceTips = gtk.Tooltips()
        # These properties are NECESSARY to maintain consistency
        # throughout USP

        # Set 'window' property for the plugin (Must be the root widget)
        self.window = self.wTree.get_widget( "window1" )
        #dic = {"on_window1_destroy" : gtk.main_quit}
        #self.wTree.signal_autoconnect(dic)

        # Set 'heading' property for plugin
        self.heading = "Places"

        # This should be the first item added to the window in glade
        self.content_holder = self.wTree.get_widget( "Places" )

        # Items to get custom colors
        self.itemstocolor = [self.wTree.get_widget( "viewport2" ),self.wTree.get_widget( "viewport1" )]

        # Gconf stuff
        self.gconf_dir = '/apps/usp/plugins/places'
        self.client = gconf.client_get_default()
        self.client.add_dir( '/apps/usp/plugins/places', gconf.CLIENT_PRELOAD_NONE )
        self.client.notify_add( '/apps/usp/plugins/places/icon_size', self.RegenPlugin )
        self.client.notify_add( '/apps/usp/plugins/places/font_size', self.RegenPlugin )
        self.client.notify_add( '/apps/usp/plugins/places/height', self.RegenPlugin )
        self.client.notify_add( '/apps/usp/plugins/places/width', self.RegenPlugin )
        self.client.notify_add( '/apps/usp/plugins/places/show_usage_bar', self.RegenPlugin )
        self.client.notify_add( '/apps/usp/plugins/places/show_tab_selection', self.RegenPlugin)

        self.bookmark_monitor = FileMonitor(os.path.join( os.path.expanduser( '~' ), '.gtk-bookmarks' ))
        self.bookmark_monitor.open()
        self.bookmark_monitor.connect("created", self.RegenPlugin)
        self.bookmark_monitor.connect("changed", self.RegenPlugin)

        self.vol_monitor = gnomevfs.VolumeMonitor()
        self.vol_monitor.connect("drive_connected", self.RegenPlugin)
        self.vol_monitor.connect("drive_disconnected", self.RegenPlugin)
        self.vol_monitor.connect("volume_mounted", self.RegenPlugin)
        self.vol_monitor.connect("volume_unmounted", self.RegenPlugin)

        self.GetGconfEntries()
        if self.showbookmarksfirst == True:
            self.wTree.get_widget( "combobox1" ).set_active(1)
            self.wTree.get_widget( "notebook1" ).set_current_page(1)
        else:
            self.wTree.get_widget( "combobox1" ).set_active(0)
            self.wTree.get_widget( "notebook1" ).set_current_page(0)
        if self.showtabs == True:
        	self.wTree.get_widget('combobox1').hide()
        	self.wTree.get_widget('notebook1').set_show_tabs(True)
        	#self.wTree.get_widget('notebook1').set_tab_label_packing(self.wTree.get_widget('scrolledwindow1'),True,True,gtk.PACK_START)
        	#self.wTree.get_widget('notebook1').set_tab_label_packing(self.wTree.get_widget('scrolledwindow2'),True,True,gtk.PACK_START)
        else:
        	self.wTree.get_widget('combobox1').show()
        	self.wTree.get_widget('notebook1').set_show_tabs(False)

	#Connect event handlers
	dic = { "on_combobox1_changed": self.ComboChanged}
	self.wTree.signal_autoconnect( dic )

    def do_reload(self):
	print "reloaded"

    def ComboChanged(self, *args, **kargs):
	sel = self.wTree.get_widget( "combobox1" ).get_active()
	self.wTree.get_widget( "notebook1" ).set_current_page(sel)

    def RegenPlugin( self, *args, **kargs ):
        self.GetGconfEntries()
        try:
        	if self.showtabs == True:
        		self.wTree.get_widget('combobox1').hide()
        		self.wTree.get_widget('notebook1').set_show_tabs(True)
        		#self.wTree.get_widget('notebook1').set_tab_label_packing(self.wTree.get_widget('scrolledwindow1'),True,True,gtk.PACK_START)
        		#self.wTree.get_widget('notebook1').set_tab_label_packing(self.wTree.get_widget('scrolledwindow2'),True,True,gtk.PACK_START)
        	else:
        		self.wTree.get_widget('combobox1').show()
        		self.wTree.get_widget('notebook1').set_show_tabs(False)
        except:
        	pass
        self.RebuildPlugin()
        self.ClearAll()
        self.do_standard_places()
        self.do_spacer()
        self.do_mounted_volumes()
        self.do_gtk_bookmarks()

    def GetGconfEntries( self ):
        self.client = gconf.client_get_default()
        self.width = SetGconf( self.client, "int", "/apps/usp/plugins/places/width", 200 )
        self.height = SetGconf( self.client, "int", "/apps/usp/plugins/places/height", 320 )
        self.execapp = SetGconf( self.client, "string", "/apps/usp/plugins/places/execute_app", "nautilus" )
        self.desktop_default = string.join( ["nautilus", os.path.join( os.path.expanduser( "~" ), "Desktop" )] )
        self.desktop = SetGconf( self.client, "string", "/apps/usp/plugins/places/desktop_cmd", self.desktop_default ).split()
        self.home_default = string.join( ["nautilus", os.path.expanduser( "~" )] )
        self.home = SetGconf( self.client, "string", "/apps/usp/plugins/places/home_cmd", self.home_default ).split()
        self.network = SetGconf( self.client, "string", "/apps/usp/plugins/places/network_cmd", "nautilus --no-desktop network:" ).split()
        self.computer = SetGconf( self.client, "string", "/apps/usp/plugins/places/computer_cmd", "nautilus --no-desktop computer:" ).split()
        self.showbookmarksfirst = SetGconf(self.client,'bool','/apps/usp/plugins/places/show_bookmarks_on_start', False )
        self.iconsize = SetGconf(self.client,"int","/apps/usp/plugins/places/icon_size",2)
        self.fontsize = SetGconf(self.client,"int","/apps/usp/plugins/places/font_size",9)
        self.usecustomcolor = SetGconf( self.client, "bool", "/apps/usp/use_custom_color", True )
        self.customcolor = SetGconfColor( self.client, "/apps/usp/custom_color", '#C1C1C1' )
        self.showusage = SetGconf( self.client, "bool", "/apps/usp/plugins/places/show_usage_bar", True )
        self.showGB = SetGconf( self.client, "bool", "/apps/usp/plugins/places/show_usage_in_GB", False )
        self.showtabs = SetGconf( self.client,'bool','/apps/usp/plugins/places/show_tab_selection', False )

        # Hide vertical dotted separator
        self.hideseparator = SetGconf( self.client, "bool", "/apps/usp/plugins/places/hide_separator", False )
        # Plugin icon
        self.icon = SetGconf( self.client, "string", '/apps/usp/plugins/places/icon', "gnome-fs-directory.png" )
        # Allow plugin to be minimized to the left plugin pane
        self.sticky = SetGconf( self.client, "bool", "/apps/usp/plugins/places/sticky", False )
        self.minimized = SetGconf( self.client, "bool", "/apps/usp/plugins/places/minimized", False )

    def SetHidden( self, state ):
	if state == True:
		WriteGconf( self.client, "bool", "/apps/usp/plugins/places/minimized", True )
	else:
		WriteGconf( self.client, "bool", "/apps/usp/plugins/places/minimized", False )

    def RebuildPlugin(self):
        self.content_holder.set_size_request(self.width, self.height )

    def ClearAll(self):
	try:
		if len(self.wTree.get_widget( "places_button_holder" ).get_children()) > 0:
	        	for i in self.wTree.get_widget( "places_button_holder" ).get_children(): 
	        	    i.destroy()
	except:
		pass

	try:
		if len(self.wTree.get_widget( "editable_button_holder" ).get_children()) > 0:
		        for i in self.wTree.get_widget( "editable_button_holder" ).get_children():
		            i.destroy()
	except:
		pass

    #Add bookmarks from Bookmarks file
    def do_gtk_bookmarks( self ):
        try:
            bookfile = open( os.path.join( os.path.expanduser( '~' ), '.gtk-bookmarks' ), 'r' )
            list = bookfile.readlines()
            for i in range( len( list ) ):
                bookmarkInfo = list[i].split()
                ButtonLocation = bookmarkInfo[0]
                ButtonCmd = [self.execapp, ButtonLocation]
                if bookmarkInfo[0][:4] == 'file':
                    ButtonIcon = "gnome-fs-directory"
                    bookmarkInfo[0] = gnomevfs.get_local_path_from_uri( bookmarkInfo[0] )
                else:
                    ext = bookmarkInfo[0][:3]
                    if ext == 'smb' or ext == 'ssh':
                        ButtonIcon = "gnome-fs-network"
                        bookmarkInfo[0] = ext + ':/' + gnomevfs.get_local_path_from_uri( 'file:/' + bookmarkInfo[0][4:] ) 
                bookmarkInfo[0] = string.join( bookmarkInfo[0].split( "%20" ) )
                # This next line doesn't work for 'smb:/' or 'ssh:/' addresses so I have moved it to the 'file' section
                #bookmarkInfo[0] = gnomevfs.get_local_path_from_uri( bookmarkInfo[0] )
                if len( bookmarkInfo ) > 2:
                    locationName = ''
                    for items in bookmarkInfo[1:]:
                        locationName = locationName + items + " "
                    locationName = [locationName]
                    Button1 = MakeAButton( 160, -1, gtk.RELIEF_NONE, ButtonIcon, self.iconsize, 48, -1, locationName, [[pango.AttrSize( self.fontsize*1000, 0, -1 )]] )
                    Button1.connect( "button_press_event", self.ButtonClicked, ButtonCmd )
                    Button1.connect( "button_release_event", self.ButtonReleased )
                    try:
                    	self.wTree.get_widget( "editable_button_holder" ).pack_start( Button1, False, False, 10 )
                    except:
                    	pass
                else:
                    locationName = [bookmarkInfo[0].split( '/' )[-1:][0]]
                    if locationName == [""]:
                        locationName = "/"
                    Button1 = MakeAButton( 160, -1, gtk.RELIEF_NONE, ButtonIcon, self.iconsize, 48, -1, locationName, [[pango.AttrSize( self.fontsize*1000, 0, -1 )]] )
                    Button1.connect( "button_press_event", self.ButtonClicked, ButtonCmd )
                    Button1.connect( "button_release_event", self.ButtonReleased )
                    try:
                    	self.wTree.get_widget( "editable_button_holder" ).pack_start( Button1, False, False, 10 )
                    except:
                    	pass
		    self.PlaceTips.set_tip(Button1, bookmarkInfo[0] , tip_private=None)
            bookfile.close()
        except:
            print "Error Accessing GTK Bookmarks"
            pass


    #Add standard places
    def do_standard_places( self ):

        PlaceData = ParseDesktopFile( "/usr/share/applications/nautilus-home.desktop" )
        Button1 = MakeAButton( 160, -1, gtk.RELIEF_NONE, PlaceData[3], self.iconsize, 48, -1, [PlaceData[0]], [[pango.AttrSize( self.fontsize*1000, 0, -1 )]] )
        Button1.connect( "button_press_event", self.ButtonClicked, self.home )
        Button1.connect( "button_release_event", self.ButtonReleased )
        try:
            self.wTree.get_widget( "places_button_holder" ).pack_start( Button1, False, False, 10 )
        except:
            pass
        self.PlaceTips.set_tip(Button1, "Home", tip_private=None)

        PlaceData = ["Desktop", "", "", "gnome-fs-desktop"]
        Button1 = MakeAButton( 160, -1, gtk.RELIEF_NONE, PlaceData[3], self.iconsize, 48, -1, [PlaceData[0]], [[pango.AttrSize( self.fontsize*1000, 0, -1 )]] )
        Button1.connect( "button_press_event", self.ButtonClicked, self.desktop )
        Button1.connect( "button_release_event", self.ButtonReleased )
        try:
            self.wTree.get_widget( "places_button_holder" ).pack_start( Button1, False, False, 10 )
        except:
            pass
        self.PlaceTips.set_tip(Button1, "Desktop", tip_private=None)

        PlaceData = ParseDesktopFile( "/usr/share/applications/nautilus-computer.desktop" )
        Button1 = MakeAButton( 160, -1, gtk.RELIEF_NONE, PlaceData[3], self.iconsize, 48, -1, [PlaceData[0]], [[pango.AttrSize( self.fontsize*1000, 0, -1 )]] )
        Button1.connect( "button_press_event", self.ButtonClicked, self.computer )
        Button1.connect( "button_release_event", self.ButtonReleased )
        try:
            self.wTree.get_widget( "places_button_holder" ).pack_start( Button1, False, False, 10 )
        except:
            pass
        self.PlaceTips.set_tip(Button1, "Computer", tip_private=None)

        PlaceData = ParseDesktopFile( "/usr/share/applications/network-scheme.desktop" )
        Button1 = MakeAButton( 160, -1, gtk.RELIEF_NONE, PlaceData[3], self.iconsize, 48, -1, [PlaceData[0]], [[pango.AttrSize( self.fontsize*1000, 0, -1 )]] )
        Button1.connect( "button_press_event", self.ButtonClicked, self.network )
        Button1.connect( "button_release_event", self.ButtonReleased )
        try:
            self.wTree.get_widget( "places_button_holder" ).pack_start( Button1, False, False, 10 )
        except:
            pass
        self.PlaceTips.set_tip(Button1, "Network", tip_private=None)

    #Add mounted volumes
    def do_mounted_volumes( self ):

        import gtop

        self.fontreduceby=0
        if self.showusage == True and self.fontsize > 3 :
            self.fontreduceby=3
        Button1 = MakeAButton( 160, -1, gtk.RELIEF_NONE, "gnome-dev-harddisk", self.iconsize, 48, -1, ["Filesystem"], [[pango.AttrSize( (self.fontsize-self.fontreduceby)*1000, 0, -1 )]] )
        Button1.connect( "button_press_event", self.ButtonClicked, [self.execapp, "/"] )
        Button1.connect( "button_release_event", self.ButtonReleased )

        usage = gtop.fsusage("/")
        percent = 100 - (usage.free * 100 / usage.total)
        if usage.total < 1048576:
            divisor = 1024.0
            symbol = "kB"
        elif usage.total < 1073741824:
            divisor = 1048576.0
            symbol = "MB"
        else:
            divisor = 1073741824.0
            symbol = "GB"
        free = usage.free * 100 / usage.total
        if self.showGB == True:
            PlaceUsage = ("%.1f"+symbol+" used %.1f"+symbol+" free") % ((usage.total-usage.free)/divisor,usage.free/1073741824.0)
	else:
            PlaceUsage = str(percent) + "% used " + str(free) + "% free"
        self.PlaceTips.set_tip(Button1,"/" + "\n" + PlaceUsage, tip_private=None)
        if self.showusage == True:
            Prog1 = gtk.ProgressBar()
            Prog1.set_size_request(-1,8)
            Prog1.set_fraction( percent / 100.00 )
            Prog1.show()
            #Prog1.connect( "button_press_event", self.ButtonClicked, [self.execapp, '/'] )
            #Prog1.connect( "button_release_event", self.ButtonReleased )
            Button1.get_children()[0].get_children()[0].get_children()[1].pack_start( Prog1, True, True, 2)
            self.PlaceTips.set_tip(Prog1,"/" + "\n" + PlaceUsage, tip_private=None)

        try:
            self.wTree.get_widget( "places_button_holder" ).pack_start( Button1, False, False, 10 )
        except:
            pass
 
        Stack=gnomevfs.VolumeMonitor().get_mounted_volumes()
        Stack.reverse()
        for volume in Stack:
            if ( volume.is_user_visible() and volume.is_mounted() and volume.get_activation_uri() ):
                Button1 = MakeAButton( 160, -1, gtk.RELIEF_NONE, volume.get_icon(), self.iconsize, 48, -1, [volume.get_display_name()], [[pango.AttrSize( (self.fontsize-self.fontreduceby)*1000, 0, -1 )]] )

                #print volume.get_activation_uri()
                URI = string.join( volume.get_activation_uri().split( "//" )[1].split( "%20" ) )
                URI = string.replace(URI,"%23","#")
                if URI[0][:4] == 'file':
                    URI = gnomevfs.get_local_path_from_uri( URI )
  
                Button1.connect( "button_press_event", self.ButtonClicked, [self.execapp, URI] )
                Button1.connect( "button_release_event", self.ButtonReleased )
                try:
                    self.wTree.get_widget( "places_button_holder" ).pack_start( Button1, False, False, 10 )
                except:
                    pass

                PlaceURI = string.join( volume.get_activation_uri().split( "//" )[1].split( "%20" ) )
                PlaceURI = string.replace(PlaceURI,"%23","#")
                if PlaceURI[0][:4] == 'file':
                    PlaceURI = gnomevfs.get_local_path_from_uri( PlaceURI )
                usage = gtop.fsusage(PlaceURI)
                if (usage.total != 0):
                    percent = 100 - (usage.free * 100 / usage.total)
                    free = usage.free * 100 / usage.total
                else:
                    percent = 0
                    free = 0
                if self.showusage == True:
                    Prog1 = gtk.ProgressBar()
                    Prog1.set_size_request(-1,8)
                    Prog1.set_fraction( percent / 100.00 )
                    Prog1.show()
                    #Prog1.connect( "button_press_event", self.ButtonClicked, [self.execapp, URI] )
                    #Prog1.connect( "button_release_event", self.ButtonReleased )
                    Button1.get_children()[0].get_children()[0].get_children()[1].pack_start( Prog1, True, True, 2)
                    self.PlaceTips.set_tip(Prog1,PlaceURI + "\n" + PlaceUsage, tip_private=None)

                if usage.total < 1048576:
                    divisor = 1024.0
                    symbol = "kB"
                elif usage.total < 1073741824:
                    divisor = 1048576.0
                    symbol = "MB"
                else:
                    divisor = 1073741824.0
                    symbol = "GB"
                if self.showGB == True:
                    PlaceUsage = ("%.1f"+symbol+" used %.1f"+symbol+" free") % ((usage.total-usage.free)/divisor,usage.free/divisor)
	        else:
                    PlaceUsage = str(percent) + "% used " + str(free) + "% free"
                self.PlaceTips.set_tip(Button1,PlaceURI + "\n" + PlaceUsage, tip_private=None)

    #Add a spacer
    def do_spacer( self ):
        sep1 = gtk.HSeparator()
        Event1 = gtk.EventBox()
        Event1.add( sep1 )
        Event1.show()
        sep1.show()
        self.SetPaneColors([Event1])
        #self.itemstocolor.append( Event1 )
        try:
            self.wTree.get_widget( "places_button_holder" ).pack_start( Event1, False, False, 10 )
        except:
            pass

    def ButtonClicked( self, widget, event, Exec ):
        self.press_x = event.x
        self.press_y = event.y
        self.Exec = Exec

    def ButtonReleased( self, w, ev ):
        if ev.button == 1:
            if not hasattr( self, "press_x" ) or \
                not w.drag_check_threshold( int( self.press_x ),
                                             int( self.press_y ),
                                             int( ev.x ),
                                             int( ev.y ) ):
		if self.USPWin.pinmenu == False:
		    	self.USPWin.wTree.get_widget( "window1" ).hide()
		if "applications" in self.USPWin.plugins:
	    		self.USPWin.plugins["applications"].wTree.get_widget( "entry1" ).grab_focus()
                print self.Exec
                Execute( w, self.Exec, False )
        #Check it's right-click and we are on Places Tab
        elif ev.button == 3:
            self.mTree = gtk.glade.XML( self.gladefile, "DriveMenu" )
            self.mTree.get_widget( "UnmountItem" ).connect( "activate", self.UnmountChosen, w, self.mTree)
            self.mTree.get_widget( "EjectItem" ).connect( "activate", self.EjectChosen, w, self.mTree )
            self.mTree.get_widget( "RemoveItem" ).connect( "activate", self.RemoveChosen, w, self.mTree, self.Exec )
            self.mTree.get_widget( "RenameItem" ).connect( "activate", self.RenameChosen, w, self.mTree, self.Exec )
            x = int( ev.x )
            y = int( ev.y )
            time = ev.time
            self.mTree.get_widget( "UnmountItem" ).hide()
            self.mTree.get_widget( "EjectItem" ).hide()
            showdrivemenu = False

            if self.wTree.get_widget('notebook1').get_current_page()==0:
                self.mTree.get_widget( "RemoveItem" ).hide()
                self.mTree.get_widget( "RenameItem" ).hide()
                for volume in gnomevfs.VolumeMonitor().get_mounted_volumes():
                    try:
                        if gnomevfs.get_local_path_from_uri( volume.get_activation_uri() ) == self.Exec[1] and self.Exec[1] != "/":
                            # Shouldn't need to do this but you never know
                            if volume.is_mounted() == True:
                                self.mTree.get_widget( "UnmountItem" ).show()
                                showdrivemenu = True
                            # print volume.get_device_type()
                            # Theses are the devices that we should be able to eject.
                            # [DEVICE_TYPE_AUDIO_CD,DEVICE_TYPE_VIDEO_DVD,DEVICE_TYPE_CDROM,DEVICE_TYPE_ZIP,DEVICE_TYPE_JAZ]
                            if volume.get_device_type() != 3 and volume.get_device_type() != 14:
                                # Show the Eject MenuItem if it is one of these
                                self.mTree.get_widget( "EjectItem" ).show()
                                showdrivemenu = True
                    except:
                        pass
            else:
                self.mTree.get_widget( "RemoveItem" ).show()
                self.mTree.get_widget( "RenameItem" ).show()
                showdrivemenu = True

            if showdrivemenu == True:
                self.mTree.get_widget( "DriveMenu" ).popup( None, None, None, ev.button, time )

    def RemoveChosen(self, menuitem, button, callingmenu, executed):
        try:
	    file = open( os.path.join( os.path.expanduser( '~' ), '.gtk-bookmarks' ), 'r' )
            list = file.readlines()
            file.close()
            Found = ""
            for line in list:
                if line.find(self.Exec[1])!=-1:
                    Found = line
                    break
            if Found != "":
                list.remove(line)
                file = open( os.path.join( os.path.expanduser( '~' ), '.gtk-bookmarks' ), 'w' )
                file.writelines(list)
                file.close()
        except:
            print "Error Removing Bookmark for "+self.Exec[1]
            pass

    def RenameChosen(self, menuitem, button, callingmenu, executed):
        try:
	    file = open( os.path.join( os.path.expanduser( '~' ), '.gtk-bookmarks' ), 'r' )
            list = file.readlines()
            file.close()
            Found = ""
            index = 0
            for line in list:
                if line.find(self.Exec[1])!=-1:
                    Found = line
                    break
                index+=1
            if Found != "":
                Names = Found.replace("\n","").split(" ")
                NumElements = len(Names)
                Result = ""
                i = 1
                if NumElements > 1:
                   while i < NumElements:
                       Result = Result+" "+Names[i]
                       i+=1
                else:
                    Result=Names[0].split("/")
                    Result=Result[-1]
                BookmarkDlg=BookmarkDialog()
                Returned=BookmarkDlg.run(Result.strip())
                if Returned != "":
                    list.remove(line)
                    line=Names[0]+" "+Returned+"\n"
                    list.insert(index,line)
                    file = open( os.path.join( os.path.expanduser( '~' ), '.gtk-bookmarks' ), 'w' )
                    file.writelines(list)
                    file.close()
        except:
            print "Error Renaming Bookmark for "+self.Exec[1]
            pass

    def UnmountChosen(self, menuitem, button, callingmenu):
        for volume in gnomevfs.VolumeMonitor().get_mounted_volumes():
            if gnomevfs.get_local_path_from_uri( volume.get_activation_uri()) == self.Exec[1]:
                try:
                    volume.unmount( self.UnmountEjectCallback )
                except:
                    print "Unable to Unmount"

    def EjectChosen(self, menuitem, button, callingmenu):
        for volume in gnomevfs.VolumeMonitor().get_mounted_volumes():
            if gnomevfs.get_local_path_from_uri( volume.get_activation_uri() ) == self.Exec[1]:
                try:
                    volume.eject( self.UnmountEjectCallback )
                except:
                    print "Unable to Eject"

    def UnmountEjectCallback(self, *args, **kargs):
        # Do Nothing except return as re-drawing is handled with FileMonitor and VolumeMonitor calls
        return

    #Generate a bookmark entry for the .gtk-bookmarks file
    def generate_bookmark( self, location, description ):
        location = string.join( location.split(), "%20" )
        if description != "":
            location += " " + description
        return location

    def SetPaneColors( self, items ):
        if self.usecustomcolor:
            for item in items:
                item.modify_bg( gtk.STATE_NORMAL, gtk.gdk.color_parse( self.customcolor ) )

    def do_plugin( self ):
        self.do_standard_places()
        self.do_spacer()
        self.do_mounted_volumes()
        self.do_gtk_bookmarks()

#---------------------------------------------------------------------------------------#
# USPconfig Section Below
#---------------------------------------------------------------------------------------#
# This is the Config Class it must be called "cfgpluginclass'
class cfgpluginclass:
    def __init__(self):
        # The Gladefile for the plugins USPconfig Tab
        self.gladefile = os.path.join(os.path.dirname(__file__), "places.glade")
        # Read GLADE file
        self.wTree = gtk.glade.XML(self.gladefile,"config")
        # Set 'window' property for the plugin (Must be the root widget)
        self.window = self.wTree.get_widget("config")
        # Set Heading, this will be used for the tab label in USPconfig
        self.heading = "Places"
        # Content Place Holder must be eventbox1
        self.content_holder = self.wTree.get_widget("eventbox2")
        # GConf Stuff - This just makes sure a gconf path is there.
        self.gconf_dir = '/apps/usp/plugins/places'
        self.client = gconf.client_get_default()
        self.client.add_dir('/apps/usp/plugins/places', gconf.CLIENT_PRELOAD_NONE)
        # Setup the Functions of the Glade files spin controls or entry boxes for Value Changes
        # Tip: For spinbutton controls use the "_value_changed" event not the "_changed" event.
        dic = { "on_window1_destroy" : gtk.main_quit,
                "on_ExeAppEntry_changed" : self.exeappchange,
                "on_DeskCmdEntry_changed" : self.deskchange,
                "on_HomeCmdEntry_changed" : self.homechange,
                "on_NetCmdEntry_changed" : self.netchange,
                "on_CompCmdEntry_changed" : self.compchange,
                "on_HideSepChkBtn_toggled" : self.hidesep,
                "on_ShowBooksChkBtn_toggled" : self.showbooks,
                "on_ShowTabsChkBtn_toggled" : self.showtabschk,
                "on_PlaceFontSizeSpin_changed" : self.placefontspin,
                "on_PlaceIconSizeSpin_changed" : self.placeiconspin,
                "on_PlaceHSpin_changed" : self.placesh,
                "on_PlaceWSpin_changed" : self.placesw,
                "on_PlaceIconEntry_changed" : self.placeiconchange,
                "on_ShowUsageBarChkBtn_toggled" : self.showusagebar,
                "on_ShowUsageGBChkBtn_toggled" : self.showusageGB,
                "on_StickyChkBtn_toggled" : self.placesticky}
        self.wTree.signal_autoconnect(dic)
        # Read Values from Gconf and Set Default Values if they don't exist.
        self.wTree.get_widget("ExeAppEntry").set_text(SetGconf(self.client, "string", "/apps/usp/plugins/places/execute_app", "nautilus"))
        self.desktop_default = string.join( ["nautilus", os.path.join( os.path.expanduser( "~" ), "Desktop" )] )
        self.wTree.get_widget("DeskCmdEntry").set_text(SetGconf(self.client, 'string', '/apps/usp/plugins/places/desktop_cmd', self.desktop_default ))
        self.home_default = string.join( ["nautilus", os.path.expanduser( "~" )] )
        self.wTree.get_widget("HomeCmdEntry").set_text(SetGconf(self.client, 'string', '/apps/usp/plugins/places/home_cmd', self.home_default ))
        self.wTree.get_widget("NetCmdEntry").set_text(SetGconf(self.client, 'string', '/apps/usp/plugins/places/network_cmd', 'nautilus --no-desktop network:' ))
        self.wTree.get_widget("CompCmdEntry").set_text(SetGconf(self.client, 'string', '/apps/usp/plugins/places/computer_cmd', 'nautilus --no-desktop computer:' ))
        self.wTree.get_widget("HideSepChkBtn").set_active(SetGconf(self.client,'bool','/apps/usp/plugins/places/hide_separator', False ))
        self.wTree.get_widget("ShowBooksChkBtn").set_active(SetGconf(self.client,'bool','/apps/usp/plugins/places/show_bookmarks_on_start', False ))
        self.wTree.get_widget("ShowTabsChkBtn").set_active(SetGconf(self.client,'bool','/apps/usp/plugins/places/show_tab_selection', False ))
        self.wTree.get_widget("PlaceFontSizeSpin").set_value(int(SetGconf(self.client,'int','/apps/usp/plugins/places/font_size',9)))
        self.wTree.get_widget("PlaceIconSizeSpin").set_value(int(SetGconf(self.client,'int','/apps/usp/plugins/places/icon_size',2)))
        self.wTree.get_widget("PlaceHSpin").set_value(int(SetGconf(self.client,'int','/apps/usp/plugins/places/height',280)))
        self.wTree.get_widget("PlaceWSpin").set_value(int(SetGconf(self.client,'int','/apps/usp/plugins/places/width',200)))
        self.wTree.get_widget("PlaceIconEntry").set_text(SetGconf(self.client,'string','/apps/usp/plugins/places/icon','computer.png'))
        self.wTree.get_widget("ShowUsageBarChkBtn").set_active(SetGconf(self.client,'bool','/apps/usp/plugins/places/show_usage_bar',False))
        self.wTree.get_widget("ShowUsageGBChkBtn").set_active(SetGconf(self.client,'bool','/apps/usp/plugins/places/show_usage_in_GB',False))
        self.wTree.get_widget("StickyChkBtn").set_active(SetGconf(self.client,'bool','/apps/usp/plugins/places/sticky',False))

    # Functions for Changing Values when items checked or altered Section
    def exeappchange(self, widget, **kargs):
                self.client.set_string('/apps/usp/plugins/places/execute_app',self.wTree.get_widget("ExeAppEntry").get_text())

    def deskchange(self, widget, **kargs):
                self.client.set_string('/apps/usp/plugins/places/desktop_cmd',self.wTree.get_widget("DeskCmdEntry").get_text())

    def homechange(self, widget, **kargs):
                self.client.set_string('/apps/usp/plugins/places/home_cmd',self.wTree.get_widget("HomeCmdEntry").get_text())

    def netchange(self, widget, **kargs):
                self.client.set_string('/apps/usp/plugins/places/network_cmd',self.wTree.get_widget("NetCmdEntry").get_text())

    def compchange(self, widget, **kargs):
                self.client.set_string('/apps/usp/plugins/places/computer_cmd',self.wTree.get_widget("CompCmdEntry").get_text())

    def placefontspin(self, widget, **kargs):
        self.client.set_int('/apps/usp/plugins/places/font_size',int(self.wTree.get_widget("PlaceFontSizeSpin").get_value()))

    def placeiconspin(self, widget, **kargs):
        self.client.set_int('/apps/usp/plugins/places/icon_size',int(self.wTree.get_widget("PlaceIconSizeSpin").get_value()))

    def placesh(self, widget, **kargs):
        self.client.set_int('/apps/usp/plugins/places/height',int(self.wTree.get_widget("PlaceHSpin").get_value()))

    def placesw(self, widget, **kargs):
        self.client.set_int('/apps/usp/plugins/places/width',int(self.wTree.get_widget("PlaceWSpin").get_value()))

    def showbooks(self, widget, **kargs):
        if self.wTree.get_widget("ShowBooksChkBtn").get_active() == True:
            self.client.set_bool('/apps/usp/plugins/places/show_bookmarks_on_start',True)
        else:
            self.client.set_bool('/apps/usp/plugins/places/show_bookmarks_on_start',False)

    def showtabschk(self, widget, **kargs):
        if self.wTree.get_widget("ShowTabsChkBtn").get_active() == True:
            self.client.set_bool('/apps/usp/plugins/places/show_tab_selection',True)
        else:
            self.client.set_bool('/apps/usp/plugins/places/show_tab_selection',False)

    def hidesep(self, widget, **kargs):
        if self.wTree.get_widget("HideSepChkBtn").get_active() == True:
            self.client.set_bool('/apps/usp/plugins/places/hide_separator',True)
        else:
            self.client.set_bool('/apps/usp/plugins/places/hide_separator',False)

    def placeiconchange(self, widget, **kargs):
        self.icon=self.wTree.get_widget("PlaceIconEntry").get_text()
        self.client.set_string('/apps/usp/plugins/places/icon',self.wTree.get_widget('PlaceIconEntry').get_text())

    def showusagebar(self, widget, **kargs):
        if self.wTree.get_widget("ShowUsageBarChkBtn").get_active() == True:
            self.client.set_bool('/apps/usp/plugins/places/show_usage_bar',True)
        else:
            self.client.set_bool('/apps/usp/plugins/places/show_usage_bar',False)

    def showusageGB(self, widget, **kargs):
        if self.wTree.get_widget("ShowUsageGBChkBtn").get_active() == True:
            self.client.set_bool('/apps/usp/plugins/places/show_usage_in_GB',True)
        else:
            self.client.set_bool('/apps/usp/plugins/places/show_usage_in_GB',False)

    def placesticky(self, widget, **kargs):
        if self.wTree.get_widget("StickyChkBtn").get_active() == True:
            self.client.set_bool('/apps/usp/plugins/places/sticky',True)
        else:
            self.client.set_bool('/apps/usp/plugins/places/sticky',False)
