#!/usr/bin/env python
# USP Shortcuts plugin

import gtk
import gtk.glade
import sys
import os
import gobject
import gconf
import gnomevfs
import string
import fnmatch
from easyfiles import *
from easybuttons import *
from execute import *
from easygconf import *


class EditDialog:
    def __init__(self):
        # Set the Glade file
        self.gladefile = os.path.join(os.path.dirname(__file__), "shortcuts.glade")

    def run(self, Data):
        """This function will show the Edit Dialog"""
        self.wTree = gtk.glade.XML(self.gladefile, "edit_dialog")
        #Get the actual dialog widget
        self.dlg = self.wTree.get_widget("edit_dialog")

        self.wTree.get_widget("edit_name_entry").set_text(Data[2][:-1][Data[2][:-1].find("=")+1:])
        self.wTree.get_widget("edit_genericname_entry").set_text(Data[6][:-1][Data[6][:-1].find("=")+1:])
        self.wTree.get_widget("edit_comment_entry").set_text(Data[3][:-1][Data[3][:-1].find("=")+1:])
        self.wTree.get_widget("edit_exec_entry").set_text(Data[4][:-1][Data[4][:-1].find("=")+1:])
        self.wTree.get_widget("edit_icon_entry").set_text(Data[5][:-1][Data[5][:-1].find("=")+1:])

        #run the dialog and store the response
        self.result = self.dlg.run()
        if self.result == -5:
            GotData = [self.wTree.get_widget("edit_name_entry").get_text(),\
            self.wTree.get_widget("edit_comment_entry").get_text(),\
            self.wTree.get_widget("edit_exec_entry").get_text(),\
            self.wTree.get_widget("edit_icon_entry").get_text(),\
            self.wTree.get_widget("edit_genericname_entry").get_text(),\
            "Terminal=False"]
        else:
            GotData = [""]

        self.dlg.destroy()
        return GotData



class pluginclass:
    TARGET_TYPE_TEXT = 80
    toButton = [ ( "text/uri-list", 0, TARGET_TYPE_TEXT ) ]

    def __init__(self, USPWin):

	self.USPWin = USPWin
        # The Glade file for the plugin
        self.gladefile = os.path.join(os.path.dirname(__file__), "shortcuts.glade")

        # Read GLADE file
        self.wTree = gtk.glade.XML(self.gladefile, "window1")

        # These properties are NECESSARY to maintain consistency
        # throughout USP

        # Set 'window' property for the plugin (Must be the root widget)
        self.window = self.wTree.get_widget("window1")
        #dic = {"on_window1_destroy" : gtk.main_quit}
        #self.wTree.signal_autoconnect(dic)

        # Set 'heading' property for plugin
        self.heading = "Shortcuts"

        # This should be the first item added to the window in glade
        self.content_holder = self.wTree.get_widget("Shortcuts")

        # Items to get custom colors
        self.itemstocolor = [self.wTree.get_widget("viewport2")]

        # Gconf stuff
        self.gconf_dir = '/apps/usp/plugins/shortcuts'
        self.client = gconf.client_get_default()
        self.client.add_dir('/apps/usp/plugins/shortcuts', gconf.CLIENT_PRELOAD_NONE)
        self.client.notify_add( '/apps/usp/plugins/shortcuts/icon_size', self.RegenPlugin )
        self.client.notify_add( '/apps/usp/plugins/shortcuts/font_size', self.RegenPlugin )
        self.client.notify_add( '/apps/usp/plugins/shortcuts/height', self.RegenPlugin )
        self.client.notify_add( '/apps/usp/plugins/shortcuts/width', self.RegenPlugin )

        # Changed to Work on the whole EventBox instead of just the holder.
        # This improves adding if there are no shortcuts already defined.
        #self.wTree.get_widget("places_button_holder").connect("drag_data_received", self.ReceiveCallback)
        #self.wTree.get_widget("places_button_holder").drag_dest_set(gtk.DEST_DEFAULT_MOTION |
        #                     gtk.DEST_DEFAULT_HIGHLIGHT |
        #                     gtk.DEST_DEFAULT_DROP,
        #                     self.toButton, gtk.gdk.ACTION_COPY)
        self.wTree.get_widget("Shortcuts").connect("drag_data_received", self.ReceiveCallback)
        self.wTree.get_widget("Shortcuts").drag_dest_set(gtk.DEST_DEFAULT_MOTION |
                             gtk.DEST_DEFAULT_HIGHLIGHT |
                             gtk.DEST_DEFAULT_DROP,
                             self.toButton, gtk.gdk.ACTION_COPY)
        self.Exec = ""
        self.RegenPlugin()


    def RegenPlugin( self, *args, **kargs ):
        self.GetGconfEntries()
        self.RebuildPlugin()
        self.do_places_file()

    def GetGconfEntries( self ):
        self.client = gconf.client_get_default()
        self.usecustomcolor = SetGconf(self.client,"bool","/apps/usp/use_custom_color",True)
        self.customcolor = SetGconfColor(self.client,"/apps/usp/custom_color",'#C1C1C1')
        self.width = SetGconf(self.client,"int","/apps/usp/plugins/shortcuts/width",200)
        self.height = SetGconf(self.client,"int","/apps/usp/plugins/shortcuts/height",270)
        self.execapp = SetGconf(self.client,"string","/apps/usp/plugins/shortcuts/execute_app", "nautilus")
        self.iconsize = SetGconf(self.client,"int","/apps/usp/plugins/shortcuts/icon_size",2)
        self.fontsize = SetGconf(self.client,"int","/apps/usp/plugins/shortcuts/font_size",9)

        self.hideseparator = SetGconf(self.client,"bool","/apps/usp/plugins/shortcuts/hide_separator",False)
        # Allow plugin to be minimized to the left plugin pane
        self.sticky = SetGconf(self.client,"bool","/apps/usp/plugins/shortcuts/sticky",False)
	self.minimized = SetGconf( self.client, "bool", "/apps/usp/plugins/shortcuts/minimized", False )

        # Plugin icon
        self.icon = SetGconf(self.client,"string",'/apps/usp/plugins/shortcuts/icon',"computer.png")

    def SetHidden( self, state ):
	if state == True:
		WriteGconf( self.client, "bool", "/apps/usp/plugins/shortcuts/minimized", True )
	else:
		WriteGconf( self.client, "bool", "/apps/usp/plugins/shortcuts/minimized", False )

    def RebuildPlugin(self):
        self.content_holder.set_size_request(self.width, self.height )

        #Add from places file
    def do_places_file(self):
        TestForDir(".usp/shortcuts")
        TestForFiles(".usp/shortcuts.list")

        PlacesFile = open (os.path.join(os.path.expanduser("~"), ".usp/shortcuts.list"), "r")
        PlacesList = PlacesFile.readlines()

        for i in self.wTree.get_widget("places_button_holder").get_children():
            i.destroy()

        for i in range(len(PlacesList)):
            if (PlacesList[i][-8:-1] == 'desktop'):
                PlaceData = ParseDesktopFile(PlacesList[i])
                if len(PlaceData) > 1:
                    Button1 = MakeAButton(180,-1,gtk.RELIEF_NONE,PlaceData[3],self.iconsize,48,-1,[PlaceData[0]],[[pango.AttrSize( self.fontsize*1000, 0, -1 )]])
                    InTerminal=False
                    if PlaceData[5].upper()=="TRUE":
                        InTerminal=True
                    Button1.connect("button_press_event",self.ButtonClicked,PlaceData[2].split())
                    Button1.connect("button_release_event",self.ButtonReleased, InTerminal)
                    Button1.MyButtonName = PlacesList[i][:-1]
                    self.wTree.get_widget("places_button_holder").pack_start(Button1, False, False, 10)
            if PlacesList[i][:-1] == "separator":
                self.do_separator("")
            if PlacesList[i][:-1] == "space":
                self.do_space("")

    #Add a space
    def do_space(self,widget,itemclicked=False,*args,**kargs):
        Event1 = gtk.EventBox()
        self.SetPaneColors([Event1])
        Event1.show()
        self.itemstocolor.append(Event1)
        self.wTree.get_widget("places_button_holder").pack_start(Event1,False,False,10)
        Event1.connect("button_press_event",self.ButtonClicked,"")
        Event1.connect("button_release_event",self.ButtonReleased, False)
        Event1.MyButtonName = "space"

        if itemclicked:
            count = 0
            for i in self.wTree.get_widget("places_button_holder").get_children():
                if itemclicked == i:
                    self.wTree.get_widget("places_button_holder").reorder_child(Event1, count)
                count = count + 1
            WriteListFile(".usp/shortcuts.list","","w")
            for i in self.wTree.get_widget("places_button_holder").get_children():
                WriteListFile(".usp/shortcuts.list",i.MyButtonName,"a")

    #Add a separator
    def do_separator(self,widget, itemclicked=False,*args,**kargs):
        sep1 = gtk.HSeparator()
        Event1 = gtk.EventBox()
        self.SetPaneColors([Event1])
        Event1.add(sep1)
        Event1.show()
        sep1.show()
        self.itemstocolor.append(Event1)
        self.wTree.get_widget("places_button_holder").pack_start(Event1,False,False,10)
        Event1.connect("button_press_event",self.ButtonClicked,"")
        Event1.connect("button_release_event",self.ButtonReleased, False)
        Event1.MyButtonName = "separator"

        if itemclicked:
            count = 0
            for i in self.wTree.get_widget("places_button_holder").get_children():
                if itemclicked == i:
                    self.wTree.get_widget("places_button_holder").reorder_child(Event1, count)
                count = count + 1
            WriteListFile(".usp/shortcuts.list","","w")
            for i in self.wTree.get_widget("places_button_holder").get_children():
                WriteListFile(".usp/shortcuts.list",i.MyButtonName,"a")

    def SetPaneColors( self, items ):
        if self.usecustomcolor:
            for item in items:
                item.modify_bg( gtk.STATE_NORMAL, gtk.gdk.color_parse( self.customcolor ) )

    def ButtonClicked(self,widget, event, Exec):
        self.press_x = event.x
        self.press_y = event.y
        self.Exec = Exec

    def ButtonReleased(self, widget, ev, InTerm):
        if ev.button == 1:
            if not hasattr(self, "press_x") or \
                not widget.drag_check_threshold(int(self.press_x),
                                             int(self.press_y),
                                             int(ev.x),
                                             int(ev.y)):
                if self.Exec != "":
		    	if self.USPWin.pinmenu == False:
		    		self.USPWin.wTree.get_widget( "window1" ).hide()
			Execute(widget,self.Exec,InTerm)

        elif ev.button == 3:
            itemclicked = widget
            self.mTree = gtk.glade.XML(self.gladefile, "menu1")
            x = int(ev.x)
            y = int(ev.y)
            time = ev.time
            self.mTree.get_widget("edit1").connect("activate", self.EditButton, widget, ev,self.mTree)
            self.mTree.get_widget("remove1").connect("activate", self.DelButton, widget, itemclicked, ev,self.mTree)
            self.mTree.get_widget("move_up1").connect("activate", self.MoveUp, widget,itemclicked, ev, self.mTree)
            self.mTree.get_widget("move_down1").connect("activate", self.MoveDown, widget,itemclicked, ev, self.mTree)
            self.mTree.get_widget("insert_space1").connect("activate", self.do_space, widget, itemclicked, ev, self.mTree)
            self.mTree.get_widget("insert_separator1").connect("activate", self.do_separator, widget, itemclicked, ev,self.mTree)
            self.mTree.get_widget("menu1").popup(None, None, None, ev.button, time)

    def DelButton(self, a, widget, itemclicked, event, menutogo, *args):
        if itemclicked.MyButtonName not in ["space", "separator"]:
            os.spawnvp(os.P_NOWAIT, "rm", ["rm", itemclicked.MyButtonName])
        itemclicked.destroy()
        menutogo.get_widget("menu1").destroy()

        WriteListFile(".usp/shortcuts.list","","w")
        for i in self.wTree.get_widget("places_button_holder").get_children():
            WriteListFile(".usp/shortcuts.list",i.MyButtonName,"a")

    def EditButton(self, a, widget, event, menutogo):
        if widget.MyButtonName not in ["space", "separator"]:
            EditDlg = EditDialog()
            openfile = open(widget.MyButtonName, 'r')
            datalist = openfile.readlines()
            result = EditDlg.run(datalist)

            if result != [""]:
                EditDesktopFile(widget.MyButtonName,result,".usp/shortcuts.list")

            self.do_places_file()
            menutogo.get_widget("menu1").destroy()


    def MoveUp(self, a, widget, itemclicked, event, menutogo, *args):
        count = 0
        for i in self.wTree.get_widget("places_button_holder").get_children():
            if itemclicked == i:
                self.wTree.get_widget("places_button_holder").reorder_child(itemclicked, count - 1)
            count = count + 1
        menutogo.get_widget("menu1").destroy()
        WriteListFile(".usp/shortcuts.list","","w")
        for i in self.wTree.get_widget("places_button_holder").get_children():
            WriteListFile(".usp/shortcuts.list",i.MyButtonName,"a")

    def MoveDown(self, a, widget, itemclicked, event, menutogo, *args):
        count = 0
        for i in self.wTree.get_widget("places_button_holder").get_children():
            if itemclicked == i:
                self.wTree.get_widget("places_button_holder").reorder_child(itemclicked, count + 1)
            count = count + 1
        menutogo.get_widget("menu1").destroy()
        WriteListFile(".usp/shortcuts.list","","w")
        for i in self.wTree.get_widget("places_button_holder").get_children():
            WriteListFile(".usp/shortcuts.list",i.MyButtonName,"a")


    def ReceiveCallback(self, widget, context, x, y, selection, targetType, time):
        PlaceData = ""
        if targetType == self.TARGET_TYPE_TEXT:
            ButtonIcon = None

            # For Folders and Network Shares
            ButtonLocation = string.join(selection.data[:-2].split("%20"))
            ButtonCmd = self.execapp + ' ' + selection.data[:-2]

            if ButtonLocation[:4] == 'file':
                ButtonIcon = "gnome-fs-directory"

            if ButtonLocation[:3] == 'smb' or ButtonLocation[:3] == 'ssh' or ButtonLocation[:7] == 'network':
                ButtonIcon = "gnome-fs-network"

            if ButtonIcon != None:
                locationName = [ButtonLocation.split('/')[-1:][0]]
                if locationName == [""]:
                    locationName = "/"
                PlaceData = [locationName[0],'',ButtonCmd,ButtonIcon,'','False']

            # For .desktop files
            if selection.data[-9:-2] == "desktop":
                PlaceData = ParseDesktopFile(selection.data[:-1])

            #For Special locations
            if selection.data[:-2] == 'x-nautilus-desktop:///computer':
                PlaceData = ParseDesktopFile("/usr/share/applications/nautilus-computer.desktop")

            if selection.data[:-2] == 'x-nautilus-desktop:///home':
                PlaceData = ParseDesktopFile("/usr/share/applications/nautilus-home.desktop")

            if selection.data[:-2] == 'x-nautilus-desktop:///network':
                PlaceData = ParseDesktopFile("/usr/share/applications/network-scheme.desktop")

            if len(PlaceData) > 1:
                Button1 = MakeAButton(180,-1,gtk.RELIEF_NONE,PlaceData[3],self.iconsize,48,-1,[PlaceData[0]],[""])
                Button1.connect("button_press_event",self.ButtonClicked,PlaceData[2].split())
                Button1.connect("button_release_event",self.ButtonReleased)
                self.wTree.get_widget("places_button_holder").pack_start(Button1, False, False, 10)


                FileExists = False
                FileData = GetFilePath(selection.data)
                clean1 = FileData.replace("/","-")
                DroppedFile = clean1.replace(" ","") +".desktop"

                for fileName in os.listdir ( os.path.join(os.path.expanduser("~"), ".usp/shortcuts" )):
                           if fnmatch.fnmatch ( fileName, DroppedFile ):
                               FileExists = True

                if FileExists == True:
                    print "File Exists!"
                    Button1.destroy()
                else:
                    DroppedFile = ".usp/shortcuts/" + DroppedFile
                    DroppedFile = os.path.join(os.path.expanduser("~"), DroppedFile)
                    print "Place added - " + DroppedFile
                    Button1.MyButtonName = DroppedFile
                    WriteDesktopFile(DroppedFile,PlaceData,".usp/shortcuts.list")
                    self.do_plugin()


    def do_plugin(self):
		   self.do_places_file()


#---------------------------------------------------------------------------------------#
# USPconfig Section Below
#---------------------------------------------------------------------------------------#
# This is the Config Class it must be called "cfgpluginclass'
class cfgpluginclass:
	def __init__(self):
		# The Gladefile for the plugins USPconfig Tab
		self.gladefile = os.path.join(os.path.dirname(__file__), "shortcuts.glade")
		# Read GLADE file
		self.wTree = gtk.glade.XML(self.gladefile,"config")
		# Set 'window' property for the plugin (Must be the root widget)
		self.window = self.wTree.get_widget("config")
		# Set Heading, this will be used for the tab label in USPconfig
		self.heading = "Shortcuts"
		# Content Place Holder must be eventbox1
		self.content_holder = self.wTree.get_widget("eventbox2")
		# GConf Stuff - This just makes sure a gconf path is there.
		self.gconf_dir = '/apps/usp/plugins/shortcuts'
		self.client = gconf.client_get_default()
		self.client.add_dir('/apps/usp/plugins/shortcuts', gconf.CLIENT_PRELOAD_NONE)
		# Setup the Functions of the Glade files spin controls or entry boxes for Value Changes
		# Tip: For spinbutton controls use the "_value_changed" event not the "_changed" event.
		dic = { "on_window1_destroy" : gtk.main_quit,
				"on_ShortWSpin_changed" : self.shortw,
				"on_ShortHSpin_changed" : self.shorth,
				"on_ExeAppEntry_changed" : self.shortexeapp,
				"on_IconSizeSpin_changed" : self.shorticon,
				"on_FontSizeSpin_changed" : self.shortfont,
				"on_HideSepChkBtn_toggled" : self.hidesep,
				"on_ShortIconEntry_changed" : self.shorticonchange,
				"on_StickyChkBtn_toggled" : self.shortsticky}
		self.wTree.signal_autoconnect(dic)
		# Read Values from Gconf and Set Default Values if they don't exist.
		self.wTree.get_widget("ShortWSpin").set_value(SetGconf(self.client,'int','/apps/usp/plugins/shortcuts/width',180))
		self.wTree.get_widget("ShortHSpin").set_value(SetGconf(self.client,'int','/apps/usp/plugins/shortcuts/height',270))
		self.wTree.get_widget("ExeAppEntry").set_text(SetGconf(self.client,'string','/apps/usp/plugins/shortcuts/execute_app', 'nautilus'))
		self.wTree.get_widget("IconSizeSpin").set_value(SetGconf(self.client,'int','/apps/usp/plugins/shortcuts/icon_size',2))
		self.wTree.get_widget("FontSizeSpin").set_value(SetGconf(self.client,'int','/apps/usp/plugins/shortcuts/font_size',9))
		self.wTree.get_widget("HideSepChkBtn").set_active(SetGconf(self.client, 'bool', '/apps/usp/plugins/shortcuts/hide_separator',False))
		self.wTree.get_widget("ShortIconEntry").set_text(SetGconf(self.client,'string','/apps/usp/plugins/shortcuts/icon','computer.png'))
		self.wTree.get_widget("StickyChkBtn").set_active(SetGconf(self.client,'bool','/apps/usp/plugins/shortcuts/sticky',False))

	# Functions for Changing Values when items checked or altered Section
	def shortw(self, widget, **kargs):
		self.client.set_int('/apps/usp/plugins/shortcuts/width',int(self.wTree.get_widget("ShortWSpin").get_value()))

	def shorth(self, widget, **kargs):
		self.client.set_int('/apps/usp/plugins/shortcuts/height',int(self.wTree.get_widget("ShortHSpin").get_value()))

	def shortexeapp(self, widget, **kargs):
		self.client.set_string('/apps/usp/plugins/shortcuts/execute_app',self.wTree.get_widget("ExeAppEntry").get_text())

	def shorticon(self, widget, **kargs):
		self.client.set_int('/apps/usp/plugins/shortcuts/icon_size',int(self.wTree.get_widget("IconSizeSpin").get_value()))

	def shortfont(self, widget, **kargs):
		self.client.set_int('/apps/usp/plugins/shortcuts/font_size',int(self.wTree.get_widget("FontSizeSpin").get_value()))

	def hidesep(self, widget, **kargs):
		if self.wTree.get_widget("HideSepChkBtn").get_active() == True:
			self.client.set_bool('/apps/usp/plugins/shortcuts/hide_separator',True)
		else:
			self.client.set_bool('/apps/usp/plugins/shortcuts/hide_separator',False)

	def shorticonchange(self, widget, **kargs):
		self.icon=self.wTree.get_widget("ShortIconEntry").get_text()
		self.client.set_string('/apps/usp/plugins/shortcuts/icon',self.wTree.get_widget('ShortIconEntry').get_text())

	def shortsticky(self, widget, **kargs):
		if self.wTree.get_widget("StickyChkBtn").get_active() == True:
			self.client.set_bool('/apps/usp/plugins/shortcuts/sticky',True)
		else:
			self.client.set_bool('/apps/usp/plugins/shortcuts/sticky',False)
